function load() {
	/* File properties dialog - setting the information */
	try {
		var strings=document.getElementById('propertiesStrings');
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var aFile=window.arguments[0];
		document.getElementById('fileIcon').setAttribute('src','moz-icon:file://'+aFile.path+'?size=32');
		document.getElementById('fileName').value=aFile.leafName;
		if (aFile.isDirectory()) {
			document.getElementById('fileExt').value='Directory';
		} else {
			document.getElementById('fileExt').value=aFile.leafName.substr(aFile.leafName.lastIndexOf('.')+1);
		}
		document.getElementById('filePath').value=aFile.path;
		if (aFile.isDirectory() && prefs.getBoolPref('extensions.firefly.calculate_dir_size')) {
			dirSizeCalc(aFile.path,0);
		} else {
			document.getElementById('rowContains').hidden=true;
			document.getElementById('fileSize').value=Math.ceil(aFile.fileSize/1024).toLocaleString()+' kB'+'('+aFile.fileSize.toLocaleString()+' B)';
		}
		
		var data=new Date(aFile.lastModifiedTime);
		document.getElementById('fileModified').value=((data.getDate()<10)?('0'+data.getDate()):data.getDate())+
										'.'+(((data.getMonth()+1)<10)?('0'+(data.getMonth()+1)):(data.getMonth()+1))+
										'.'+data.getFullYear()+
										'   '+((data.getHours()<10)?('0'+data.getHours()):(data.getHours()))+
										':'+((data.getMinutes()<10)?('0'+data.getMinutes()):(data.getMinutes()));
		
		if (aFile.isSymlink()) {
			document.getElementById('targetBox').collapsed=false;
			document.getElementById('fileTarget').value=aFile.target;
		} else {
			document.getElementById('targetBox').collapsed=true;
		}
		
		var permissions = getFilePermissions(aFile.permissions);
		if (aFile.isDirectory()) {
			permissions = 'd'+permissions;
		} else if(aFile.isSymlink()) {
			permissions = 'l'+permissions;
		} else {
			permissions = '-'+permissions;
		}
		
		document.getElementById('fileIsReadable').value=strings.getString('readable')+" "+(aFile.isReadable()?strings.getString('yes'):strings.getString('no'));
		document.getElementById('fileIsWritable').value=strings.getString('writable')+" "+(aFile.isWritable()?strings.getString('yes'):strings.getString('no'));
		document.getElementById('fileIsExecutable').value=strings.getString('executable')+" "+(aFile.isExecutable()?strings.getString('yes'):strings.getString('no'));
		document.getElementById('fileIsHidden').value=strings.getString('hidden')+" "+(aFile.isHidden()?strings.getString('yes'):strings.getString('no'));
		document.getElementById('fileIsDir').value=strings.getString('directory')+" "+(aFile.isDirectory()?strings.getString('yes'):strings.getString('no'));
		document.getElementById('fileIsFile').value=strings.getString('file')+" "+(aFile.isFile()?strings.getString('yes'):strings.getString('no'));
		document.getElementById('fileIsSymlink').value=strings.getString('symlink')+" "+(aFile.isSymlink()?strings.getString('yes'):strings.getString('no'));
		document.getElementById('fileIsSpecial').value=strings.getString('special')+" "+(aFile.isSpecial()?strings.getString('yes'):strings.getString('no'));
		document.getElementById('filePermissions').value=strings.getString('permissions')+" "+permissions;
		
		//document.getElementById('renameText').value=window.arguments[0].leafName;
		document.getElementById('propertiesDialog').centerWindowOnScreen();
	} catch (e) {
		errorLogger(e);
	}
}

function getPermissionsByNumber(num) {
	switch (num) {
		case '7':
			var ret = 'rwx';
			break;
		case '6':
			var ret = 'rw-';
			break;
		case '5':
			var ret = 'r-x';
			break;
		case '4':
			var ret = 'r--';
			break;
		case '3':
			var ret = '-wx';
			break;
		case '2':
			var ret = '-w-';
			break;
		case '1':
			var ret = '--x';
			break;
		case '0':
			var ret = '---';
			break;
		default: 
			break;
	}
	return ret;
}
function getFilePermissions(permissions) {
	var octalPermissions = permissions.toString(8);
	var last = octalPermissions.substr(octalPermissions.length-1,1);
	var middle = octalPermissions.substr(octalPermissions.length-2,1);
	var first = octalPermissions.substr(octalPermissions.length-3,1);
	var perm = getPermissionsByNumber(first)+getPermissionsByNumber(middle)+getPermissionsByNumber(last);
	return perm;
}

function doOK() {
	return true;
}
function errorLogger(e) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var alertErrors=prefs.getBoolPref('extensions.firefly.alert_errors');
	if (alertErrors) {
		alert(e.message);
	}
	
	var date=new Date();
	var data='File name:'+(e.fileName?e.fileName:'')+'\tLine number:'+(e.lineNumber?e.lineNumber:'')+
		'\tDate:'+date.getDate()+'.'+date.getMonth()+'.'+date.getFullYear()+'\t'+date.getHours()+':'+date.getMinutes()+':'+date.getSeconds()+
		'\tMessage:'+(e.message?e.message:'')+'\tName:'+(e.name?e.name:'')+'\tConstructor:'+(e.constructor?e.constructor:'')+'\r\n';
	var file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
	file.append('firefly.err');
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                         .createInstance(Components.interfaces.nsIFileOutputStream);
	if (file.exists()) {
		if (file.fileSize>20000) {
			foStream.init(file,  0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
		} else {
			foStream.init(file,  0x02 | 0x08 | 0x10, 0664, 0); // write, create, append
		}
	} else {
		foStream.init(file,  0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
		
	}
	
	
	foStream.write(data, data.length);
	foStream.close();
}

function doCancel() {
	return true;
}
function dirSizeCalc(dir,multiplier) {
	/* Calculate the dir size for the file properties dialog - 
		currently calculated size is stored in an attribute of the size description 
		new dirs when scanned are added to an array
		multiplier is used to minimize possibility of UI lock
	*/
	try {
		var sizeDesc=document.getElementById('fileSize');
		
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var dirScanInterval=prefs.getIntPref('extensions.firefly.dir_scan_interval');
		var dirs=new Array();
		var files=new Array();
		var next;
		var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
		if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
		aFolder.initWithPath(dir);
		var folderEntries=aFolder.directoryEntries;
		while (folderEntries.hasMoreElements()) {
			next=folderEntries.getNext().QueryInterface(Components.interfaces.nsILocalFile);
			if (next.isDirectory()) {
				dirs.push(next);
			} else {
				files.push(next);
			}
		}
		dirs.sort(nameSort);
		files.sort(nameSort);
		var filesANDdirs=Array.concat(dirs,files);
		multiplier++;
		for (var i=0;i<filesANDdirs.length;i++) {
			if (filesANDdirs[i].isDirectory()) {
				var dirName=filesANDdirs[i].path;
				dirName=dirName.replace(/\\/g,'\\\\');
				setTimeout('dirSizeCalc("'+dirName+'",'+multiplier+')',(multiplier+i)*dirScanInterval);
			} else {
				try {
					sizeDesc.setAttribute('size',(Math.ceil(sizeDesc.getAttribute('size'))+Math.ceil(filesANDdirs[i].fileSize)));
					sizeDesc.value='Size: '+Math.ceil(sizeDesc.getAttribute('size')/1024).toLocaleString()+' kB';
				} catch (e) {
					return null;
				}
			}
		}
		document.getElementById('dirContains').setAttribute('files',Math.ceil(document.getElementById('dirContains').getAttribute('files'))+files.length);
		document.getElementById('dirContains').setAttribute('dirs',Math.ceil(document.getElementById('dirContains').getAttribute('dirs'))+dirs.length);
		document.getElementById('dirContains').setAttribute('value',document.getElementById('dirContains').getAttribute('files')+' files, '+document.getElementById('dirContains').getAttribute('dirs')+' dirs');
	} catch (e) {
		errorLogger(e);
	}
	return null;
}

function nameSort(el1,el2) {
	/* Sort by file name */
	var sortDir='asc'
	if (el1.leafName.toUpperCase()>el2.leafName.toUpperCase()) {
		if (sortDir=='asc') {
			return -1;
		} else {
			return 1;
		}
	} else if (el2.leafName.toUpperCase()>el1.leafName.toUpperCase()) {
		if (sortDir=='asc') {
			return 1;
		} else {
			return -1;
		}
	} else {
		return 0;
	}
}