/* Formats dialogs */
	function getFormatIds(type) {
		var new_formatId;
		var preferenceId;
		var listboxId;
		var removeId;
		switch (type) {
			case 'movie':
				new_formatId='new_format_movie';
				preferenceId='movie_types';
				listboxId='movieTypesList';
				removeId='removeFormatMovie';
				break;
			case 'music':
				new_formatId='new_format_music';
				preferenceId='music_types';
				listboxId='musicTypesList';
				removeId='removeFormatMusic';
				break;
			case 'image':
				new_formatId='new_format_image';
				preferenceId='image_types';
				listboxId='imageTypesList';
				removeId='removeFormatImage';
				break;
			case 'document':
				new_formatId='new_format_document';
				preferenceId='document_types';
				listboxId='documentTypesList';
				removeId='removeFormatDocument';
				break;
			case 'pdf':
				new_formatId='new_format_pdf';
				preferenceId='pdf_types';
				listboxId='pdfTypesList';
				removeId='removeFormatPdf';
				break;
			case 'icons':
				new_formatId='new_format_icon';
				preferenceId='file_icons';
				listboxId='iconsList';
				removeId='removeIconType';
				break;
		}
		return new Array(new_formatId,preferenceId,listboxId,removeId);
	}
	function addFormat(type) {
		/* Add format to the listbox */
		var ids=getFormatIds(type);
		var listbox=document.getElementById(ids[2]);
		var list=document.createElement('listitem');	//'<listitem label="'+sendToArray[i]+'" />';
		list.setAttribute('label',document.getElementById(ids[0]).value);
		document.getElementById(ids[0]).value='';
		//list.setAttribute('onclick','enableRemove("'+ids[3]+'");');
		if (type=='icons') {
			list.setAttribute('value','mime.png');
			//list.setAttribute('onclick','enableRemove("'+ids[3]+'");setIcons(this);');
		} else {
			//list.setAttribute('onclick','enableRemove("'+ids[3]+'");');
		}
		listbox.insertBefore(list,listbox.firstChild);
		// fireEvent('change',listbox);
		setTimeout("fireEvent('change',document.getElementById('"+ids[2]+"'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
	}
	function removeFormat(type) {
		/* Remove a format from the listbox */
		var ids=getFormatIds(type);
		var listbox=document.getElementById(ids[2]);
		listbox.removeChild(listbox.selectedItem);
		document.getElementById(ids[3]).disabled=true;
		if (type=='icons') {
			document.getElementById('get16Icon').disabled=true;
			document.getElementById('get32Icon').disabled=true;
		}
		// fireEvent('change',listbox);
		setTimeout("fireEvent('change',document.getElementById('"+ids[2]+"'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
	}
	function loadFileTypes(type) {
		/* Create the listbox items for the corresponding preference */
		var ids=getFormatIds(type);
		var preference=document.getElementById(ids[1]);
		var listbox=document.getElementById(ids[2]);
		var list;
		var fileTypesArray=new Array();
		if (type=='icons') {
			eraseContent(listbox);
			fileTypesArray=preference.value.split('|');
			
			for (var i=0;i<fileTypesArray.length;i++) {
				var temp=new Array();
				temp=fileTypesArray[i].split('=');
				var pic=temp[0];
				var types=temp[1].split(',');
				for (var j=0;j<types.length;j++) {
					/*list=document.createElement('listitem');	//'<listitem label="'+sendToArray[i]+'" />';
					list.setAttribute('pic',pic);
					list.setAttribute('label',types[j]);
					list.setAttribute('onclick','enableRemove("'+ids[3]+'");setIcons(this);');
					list.setAttribute('id',types[j]);
					listbox.appendChild(list);*/
					listbox.appendItem(types[j],pic);
				}
			}
		} else {
			fileTypesArray=preference.value.split(',');
			eraseContent(listbox);
			for (var i=0;i<fileTypesArray.length;i++) {
				/*list=document.createElement('listitem');	//'<listitem label="'+sendToArray[i]+'" />';
				list.setAttribute('label',fileTypesArray[i]);
				list.setAttribute('onclick','enableRemove("'+ids[3]+'");');
				listbox.appendChild(list);*/
				listbox.appendItem(fileTypesArray[i]);
			}
		}
	}
	function saveFileTypes(type) {
		/* Return the content of the listbox as comma separated string so they can be saved by the preference dialog */
		var ids=getFormatIds(type);
		var returnString='';
		var elements=document.getElementById(ids[2]).childNodes;
		
		if (type=='icons') {
			var arrIcon=new Object;
			for (var i=0;i<elements.length;i++) {
				var pic=elements[i].getAttribute('value');
				if (arrIcon[pic]==undefined) {
					arrIcon[pic]=elements[i].label;
				} else{
					arrIcon[pic]=arrIcon[pic]+','+elements[i].label;
				}
			}
 			//alert(arrIcon['mime']);
			
			for (var i=0 in arrIcon) {
				if (returnString=='') {
					returnString=i+'='+arrIcon[i];
				} else {
					returnString+='|'+i+'='+arrIcon[i];
				}
			}
		} else {
			for (var i=0;i<elements.length;i++) {
				if (i==0) {
					returnString+=elements[i].label;
				} else {
					returnString+=','+elements[i].label;
				}
			}
		}
		return returnString;
	}
/* End formats dialogs*/


// Listboxes
	function getIds(dialog) {
		var picker;
		var listId;
		var removeId;
		var preferenceId;
		var textboxId;
		var alias;
		var nsIFilePicker = Components.interfaces.nsIFilePicker;		// Available modes: modeOpen, modeSave, modeGetFolder, modeOpenMultiple.
		switch (dialog) {
			case 'tree':
				picker=nsIFilePicker.modeGetFolder;
				listId='treeOptionsList';
				removeId='removeTreeOptions';
				preferenceId='tree_options';
				textboxId='newTreeItem';
				alias='treeAlias';
				break;
			case 'sendto':
				picker=nsIFilePicker.modeGetFolder;
				listId='sendToList';
				removeId='removeSendTo';
				preferenceId='send_to_string';
				textboxId='newSentToItem';
				alias='sendtoAlias';
				break;
			case 'openwith':
				picker=nsIFilePicker.modeOpen;
				listId='OpenWithList';
				removeId='removeOpenWith';
				preferenceId='open_with_string';
				textboxId='newOpenWithItem';
				alias='openwithAlias';
				break;
		}
		return new Array(picker,listId,removeId,preferenceId,textboxId,alias);
	}
	function selectDialog(dialog) {
		/* Display select dialog or add the textbox value to the listbox */
		var ids=getIds(dialog);
		
		if (document.getElementById(ids[4]).value!='') {
			var elements=document.getElementById(ids[1]).childNodes;
			for (var i=0;i<elements.length;i++) {
				if (elements[i].label.toLowerCase()==document.getElementById(ids[4]).value.toLowerCase()) {
					return -1;
				}
			}
			var listbox=document.getElementById(ids[1]);
			var list=document.createElement('listitem');	//'<listitem label="'+sendToArray[i]+'" />';
			if (listbox.getRowCount()==1) {
				var first=listbox.getItemAtIndex(0);
				if (first.label=='') {
					listbox.removeItemAt(0);
				}
			}
			/*list.setAttribute('label',document.getElementById(ids[4]).value);
			//list.setAttribute('onclick','enableRemove("'+ids[2]+'");');
			list.value=document.getElementById(ids[5]).value;
			// listbox.appendChild(list);
			listbox.insertBefore(list,listbox.firstChild);*/
			
			listbox.appendItem(document.getElementById(ids[4]).value,document.getElementById(ids[5]).value);
			
			document.getElementById(ids[4]).value='';
			document.getElementById(ids[5]).value='';
			// fireEvent('change',listbox);
			setTimeout("fireEvent('change',document.getElementById('"+ids[1]+"'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
		} 
		return -1;
	}
	function removeItem(dialog) {
		/* Remove the selected listbox item */
		var ids=getIds(dialog);
		var listbox=document.getElementById(ids[1]);
		listbox.removeChild(listbox.selectedItem);
		document.getElementById(ids[2]).disabled=true;
		// fireEvent('change',listbox);
		setTimeout("fireEvent('change',document.getElementById('"+ids[1]+"'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
	}
	function loadItems(dialog) {
		/* Loads the listbox from the preferences */
		var ids=getIds(dialog);
		var preference=document.getElementById(ids[3]);
		var listbox=document.getElementById(ids[1]);
		var list;
		var sendToArray=new Array;
		sendToArray=preference.value.split('|');
		eraseContent(listbox);
		for (var i=0;i<sendToArray.length;i++) {
			list=document.createElement('listitem');	//'<listitem label="'+sendToArray[i]+'" />';
			var val=sendToArray[i].split('=');
			/*list.setAttribute('label',val[0]);
			list.setAttribute('value',val[1]);
			list.setAttribute('onclick','enableRemove("'+ids[2]+'");loadAlias("'+dialog+'",this)');
			listbox.appendChild(list);*/
			listbox.appendItem(val[0],val[1]);
		}
	}
	function loadAlias(dialog,el) {
		var ids=getIds(dialog);
		document.getElementById(ids[5]).value=el.value;
		document.getElementById(ids[4]).value=el.label;
		document.getElementById(ids[2]).setAttribute('disabled','false');
	}
	function saveItems(dialog) {
		/* Save listbox items to the preferences */
		var ids=getIds(dialog);
		var returnString='';
		var elements=document.getElementById(ids[1]).childNodes;
		for (var i=0;i<elements.length;i++) {
			if (i==0) {
				returnString+=elements[i].label+'='+elements[i].value;
			} else {
				returnString+='|'+elements[i].label+'='+elements[i].value;
			}
		}
		return returnString;
	}
	function browseFor(dialog) {
		var ids=getIds(dialog);
		
		try {
			var nsIFilePicker = Components.interfaces.nsIFilePicker;
			var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
			fp.init(window, translate('wndSelect'), ids[0]);
			if (dialog=='openwith') {
				fp.appendFilters(nsIFilePicker.filterApps);//# Available filters: filterAll, filterHTML, filterText, filterImages, filterXML, filterXUL, filterApps. 
				fp.filterIndex=nsIFilePicker.filterApps;
			}
			var res = fp.show();
			if (res == nsIFilePicker.returnOK){
				var thefile = fp.file;
				
				document.getElementById(ids[4]).value=thefile.path;
				
				/*var elements=document.getElementById(ids[1]).childNodes;
				for (var i=0;i<elements.length;i++) {
					if (elements[i].label.toLowerCase()==thefile.path.toLowerCase()) {
						return -1;
					}
				}
				var listbox=document.getElementById(ids[1]);
				var list=document.createElement('listitem');	//'<listitem label="'+sendToArray[i]+'" />';
				list.setAttribute('label',thefile.path);
				list.setAttribute('onclick','enableRemove("'+ids[2]+'");');
				listbox.appendChild(list);
				fireEvent('change',listbox);*/
			}
		} catch (e) {
			errorLogger(e);
		}
	}
	function move(direction,dialog) {
		try {
			var ids=getIds(dialog);
			var listbox=document.getElementById(ids[1]);
			var selected=listbox.selectedIndex;
			if (selected!=-1) {
				var selectedItem=listbox.getItemAtIndex(selected);
			} else {
				return;
			}
			if (direction=='up') {
				if (selected>0) {
					/*listbox.insertItemAt(selected-1,selectedItem.label,selectedItem.value);
					listbox.removeItemAt(selected+1);*/
					
					var oldLabel=selectedItem.label;
					var oldValue=selectedItem.value;
					
					selectedItem.label=listbox.childNodes[selected-1].label;
					selectedItem.value=listbox.childNodes[selected-1].value;
					listbox.childNodes[selected-1].label=oldLabel;
					listbox.childNodes[selected-1].value=oldValue;
					listbox.selectedIndex=selected-1;
				}
			} else if (direction=='down') {
				if (selected<listbox.getRowCount()) {
					/*var selectedItem=listbox.getItemAtIndex(selected+1);
					listbox.insertItemAt(selected,selectedItem.label,selectedItem.value);
					listbox.removeItemAt(selected+2);*/
					
					var oldLabel=selectedItem.label;
					var oldValue=selectedItem.value;
					
					selectedItem.label=listbox.childNodes[selected+1].label;
					selectedItem.value=listbox.childNodes[selected+1].value;
					listbox.childNodes[selected+1].label=oldLabel;
					listbox.childNodes[selected+1].value=oldValue;
					listbox.selectedIndex=selected+1;
				}
			}
			setTimeout("fireEvent('change',document.getElementById('"+ids[1]+"'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
		} catch (e) {
			errorLogger(e);
		}
	}
	
	function setAlias(dialog) {
		var ids=getIds(dialog);
		var listbox=document.getElementById(ids[1]);
		var selected=listbox.selectedIndex;
		if (selected!=-1) {
			var selectedItem=listbox.getItemAtIndex(selected);
		} else {
			return;
		}
		selectedItem.value=document.getElementById(ids[5]).value;
		selectedItem.label=document.getElementById(ids[4]).value;
		// fireEvent('change',listbox);
		setTimeout("fireEvent('change',document.getElementById('"+ids[1]+"'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
	}
//end listboxes
/* Fire an event so that the properties dialog can understand something has changed and get the new values */
function fireEvent(name, target) {
	//Ready: create a generic event 
	var evt = document.createEvent("Events")
	//Aim: initialize it to be the event we want
	evt.initEvent(name, true, true); //true for can bubble, true for cancelable
	//FIRE!
	target.dispatchEvent(evt);
}
function eraseContent(el) {		// erases all children of a tag
	var cycles=el.childNodes.length;
	for (var p=0;p<cycles;p++) {
		el.removeChild(el.childNodes[0]);
	}
}

function enableRemove(id) {
	/* Enable the remove button */
	var button=document.getElementById(id);
	button.setAttribute('disabled','false');
}

function setIcons(el) {
	/* set the picture to the side views*/
// 	alert(el.getAttribute('pic'));
	document.getElementById('icon32').src='chrome://firefly/skin/mime/32/'+el.getAttribute('value');
	document.getElementById('icon16').src='chrome://firefly/skin/mime/16/'+el.getAttribute('value');
	document.getElementById('get32Icon').disabled=false;
	document.getElementById('get16Icon').disabled=false;
	document.getElementById('get32Icon').setAttribute('backTo',el.parentNode.selectedIndex);	/*el.id*/
	document.getElementById('get16Icon').setAttribute('backTo',el.parentNode.selectedIndex);	/*el.id*/
}
function getIcon(size) {
	var nsIFilePicker=Components.interfaces.nsIFilePicker
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);
	fp.init(window, translate('wndSelectIcon'), nsIFilePicker.modeOpen);
	fp.appendFilters(nsIFilePicker.filterImages);
	
	var rv = fp.show();
	if (rv == nsIFilePicker.returnOK) {
		var GUID = "firefly.filemanager@gmail.com";
		var nsIExtensionManager = Components.classes["@mozilla.org/extensions/manager;1"]
			.getService(Components.interfaces.nsIExtensionManager);
		var extDir=nsIExtensionManager.getInstallLocation(GUID).getItemLocation(GUID);
		extDir.append('chrome');
		extDir.append('skin');
		extDir.append('classic');
		extDir.append('mime');
		
		var file = fp.file;
		if (size=='big') {
			extDir.append('32');
			file.copyTo(extDir,null);
			document.getElementById('icon32').src='chrome://firefly/skin/mime/32/'+file.leafName;
			document.getElementById('iconsList').childNodes[document.getElementById('get32Icon').getAttribute('backTo')].setAttribute('value',file.leafName);
			// document.getElementById(document.getElementById('get32Icon').getAttribute('backTo')).setAttribute('value',file.leafName);
		} else {
			extDir.append('16');
			file.copyTo(extDir,null);
			document.getElementById('icon16').src='chrome://firefly/skin/mime/16/'+file.leafName;
			document.getElementById('iconsList').childNodes[document.getElementById('get16Icon').getAttribute('backTo')].setAttribute('value',file.leafName);
			// document.getElementById(document.getElementById('get16Icon').getAttribute('backTo')).setAttribute('value',file.leafName);
		}
		// fireEvent('change',document.getElementById('iconsList'));
		setTimeout("fireEvent('change',document.getElementById('iconsList'))",1);		// NOTE: need timeout because otherwise the last(invisible) listitems will become udefined!!!
	}
}

function errorLogger(e) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var alertErrors=prefs.getBoolPref('extensions.firefly.alert_errors');
	if (alertErrors) {
		alert(e.message);
	}
	
	var date=new Date();
	var data='File name:'+(e.fileName?e.fileName:'')+'\tLine number:'+(e.lineNumber?e.lineNumber:'')+
		'\tDate:'+date.getDate()+'.'+date.getMonth()+'.'+date.getFullYear()+'\t'+date.getHours()+':'+date.getMinutes()+':'+date.getSeconds()+
		'\tMessage:'+(e.message?e.message:'')+'\tName:'+(e.name?e.name:'')+'\tConstructor:'+(e.constructor?e.constructor:'')+'\r\n';
	var file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
	file.append('firefly.err');
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                         .createInstance(Components.interfaces.nsIFileOutputStream);
	if (file.exists()) {
		if (file.fileSize>20000) {
			foStream.init(file,  0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
		} else {
			foStream.init(file,  0x02 | 0x08 | 0x10, 0664, 0); // write, create, append
		}
	} else {
		foStream.init(file,  0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
		
	}
	
	
	foStream.write(data, data.length);
	foStream.close();
}
function translate(str) {
	return document.getElementById('optionsStrings').getString(str);
}
function load(what,el) {
	var ids=getFormatIds(what);
	document.getElementById(ids[3]).setAttribute('disabled','false');
	switch (what) {
		case 'movie':
		case 'music':
		case 'image':
		case 'document':
		case 'pdf':
			break;
		case 'icons':
			setIcons(el);
			break;
	}
}