const FIREFLY_XUL_FILE = "chrome://firefly/content/firefly.xul"
const FIREFLY_APP_NAME = "Firefly"
var fireflyStarterArray=new Array();
var win = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
		.getInterface(Components.interfaces.nsIWebNavigation)
		.QueryInterface(Components.interfaces.nsIDocShellTreeItem)
		.rootTreeItem
		.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
					.getInterface(Components.interfaces.nsIDOMWindow);

var treeView = {
	visibleData : fireflyStarterArray,
	childData : function (idx) {
		/* Get the subfolders of the requested(when opening a twisty) sort them and return them so they can be aded to the array in the tree */
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		var showHiddenFiles=prefs.getBoolPref('extensions.firefly.hidden_files');
		try {
			var dirs=new Array();
			var path=this.visibleData[idx][0];
			var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
			if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
			aFolder.initWithPath(path);
			try {
				var folderEntries=aFolder.directoryEntries;
			} catch (err) {
				return new Array();
			}
			while (folderEntries.hasMoreElements()) {
				next=folderEntries.getNext().QueryInterface(Components.interfaces.nsILocalFile);
				if (next.isDirectory()) {
					if ((next.isHidden() && showHiddenFiles) || !next.isHidden()) {
						dirs.push(next);
					}
				}
			}
			dirs.sort(nameSort);
		} catch (e) {
			errorLogger(e);
		}
		return dirs;
	},
	treeBox: null,
	selection: null,
	getSelectedElement: function(idx) {
		return this.visibleData[idx];
	},
	get rowCount()                     { return this.visibleData.length; },
	setTree: function(treeBox)         { this.treeBox = treeBox; },
	getCellText: function(idx, column) { return this.visibleData[idx][3]; },
	isContainer: function(idx)         { return true; },
	isContainerOpen: function(idx)     { return this.visibleData[idx][2]; },
	isContainerEmpty: function(idx)    { 
		/* Determine if the current folder has subfolders (needed to display the twisty) */
		if (this.visibleData[idx][1]!=0) {
			return this.visibleData[idx][4]; 
		} else {
			var children=this.childData(idx);
			if (children.length>0) {
				return false;
			} else {
				if (this.isContainerOpen(idx)) {
					this.toggleOpenState(idx);
				}
				return true;
			}
		}
	},
	isSeparator: function(idx)         { return false; },
	isSorted: function(path) { return false;},
	isEditable: function(idx, column)  { return true; },
	getParentIndex: function(idx) {
		/* Determine the parent folder */
		var currentLevel=this.visibleData[idx][1];
		if (currentLevel==0) return -1;
		for (var i=idx-1;i>=0;i--) {
			if (this.visibleData[i][1]<currentLevel) {
				return i;
			}
		}
		return -1;
	},
	getLevel: function(idx) { return this.visibleData[idx][1]; },
	hasNextSibling: function(idx, after) {
		/* Determin if there are more childeren after the current */
		var currentLevel=this.visibleData[idx][1];
		if (idx==this.rowCount-1) {
			return false;
		}
		if (this.visibleData[idx+1][1]==currentLevel) {
			return true;
		}
		return false;
	},
	toggleOpenState: function(idx) {
		/* When click on the twisty or double click open/close the corresponding folder */
		if (this.visibleData[idx][2]) {
			this.visibleData[idx][2]=false;
			var currentLevel=this.visibleData[idx][1];
			var deletecount = 0;
			for (var t = idx + 1; t < this.visibleData.length; t++) {
				if (this.visibleData[t][1] > currentLevel) deletecount++;
				else break;
			}
			if (deletecount) {
				this.visibleData.splice(idx + 1, deletecount);
				this.treeBox.rowCountChanged(idx + 1, -deletecount);
			}
		} else {
			this.visibleData[idx][2]=true;
			var currentLevel=this.visibleData[idx][1];
			var toinsert = this.childData(idx);
			var empty;
			for (var i = 0; i < toinsert.length; i++) {
				empty=isEmpty(toinsert[i].path);
				this.visibleData.splice(idx + i + 1, 0, [toinsert[i].path,(currentLevel+1), false,toinsert[i].leafName,empty,toinsert[i].isHidden()]);
			}
			this.treeBox.rowCountChanged(idx + 1, toinsert.length);
		}
	},
	getImageSrc: function(idx, column) {
		/* Display icons for the folders in the tree */
		try {
			var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			var showInternalIcons=prefs.getBoolPref('extensions.firefly.show_internal_icons');
			var noIcons=prefs.getBoolPref('extensions.firefly.no_icons');
			if (!noIcons) {
				if (showInternalIcons) {
					return 'chrome://firefly/skin/mime/16/folder.png';
				} else {
					var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
					if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
					aFolder.initWithPath(this.visibleData[idx][0]);
					return "moz-icon:file://"+aFolder.path+'?size=16';/*return null;*/ 
				}
			}
		} catch (e) {
			errorLogger(e);
		}
		return null;
	},
	getProgressMode : function(idx,column) {},
	getCellValue: function(idx, column) {},
	cycleHeader: function(col, elem) {},
	//selectionChanged: function() {},
	selectionChanged: function() {
		/* When clicked on a folder in the tree display it in the currently active subwindow */
		var currentElement=this.getSelectedElement(this.selection.currentIndex);
		var doc=selectedTabDocument();//.wrappedJSObject;
		
		var addressElement=doc.getElementById('firefly_addresbox');
		
		var deckElement=doc.getElementById('containing_deck');
		var currentSubwindow=doc.getElementById(deckElement.getAttribute('currentSubwindow'));
		if(currentElement) {
			addressElement.value=currentElement[0];
			currentSubwindow.path=currentElement[0];
			currentSubwindow.refresh();
		}
	},
	cycleCell: function(idx, column) {},
	performAction: function(path) {
		/* When clicked on a subwindow navigate the tree to the correct folder and select it */
		if (document.getElementById('elementList').getAttribute('oldPath')!=path) {
			document.getElementById('elementList').setAttribute('oldPath',path)
			var searchedIndex=0;
			
			var length=this.visibleData.length;
			var i=0;
			//for (var i=0;i<length;i++) {
			while(length>i) {
				path1=this.visibleData[i][0];
				if (path1.toLowerCase()==path.toLowerCase()) {
					searchedIndex=i;
					break;
				} else if (path.toLowerCase().indexOf(path1.toLowerCase())!=-1) {
						if (!this.isContainerEmpty(i) && !this.isContainerOpen(i)) {
							this.toggleOpenState(i);
							length=this.visibleData.length;
						}
				} else {
					searchedIndex=-1;
				}
				i++;
			}
			
			this.selection.select(searchedIndex);
		}
	},
	performActionOnCell: function(action, index, column) {},
	performActionOnRow: function (action, row) {},
	getRowProperties: function(idx, column, prop) {},
	getCellProperties: function(idx, column, prop) {
		var aserv=Components.classes["@mozilla.org/atom-service;1"].getService(Components.interfaces.nsIAtomService);
		if (this.visibleData[idx][5]) {		// show hidden folders differently
			prop.AppendElement(aserv.getAtom('hidden'));
		}
	},
	getColumnProperties: function(column, element, prop) {}
}

function translate(str) {
	return document.getElementById('treeStrings').getString(str);
}
;
function selectedTabDocument() {
	// return the document in the currently selected tab
	return content.document;
}
function nameSort(el1,el2) {
	// sort by name
	var sortDir='asc'
	if (el1.leafName.toUpperCase()>el2.leafName.toUpperCase()) {
		return 1;
	} else if (el2.leafName.toUpperCase()>el1.leafName.toUpperCase()) {
		return -1;
	} else {
		return 0;
	}
}
function init() {
	/* Initialize the tree and the starter array(the folders chosen by the user) */
	try {
		var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
		// var starterString=prefs.getCharPref('extensions.firefly.tree_options');
		var starterString=prefs.getComplexValue('extensions.firefly.tree_options',Components.interfaces.nsISupportsString).data;
		var tempArray=starterString.split('|');
		var leafName='';
		for (var i=0;i<tempArray.length;i++) {
			var val=tempArray[i].split('=');
			var path=val[0];
			if (path != '' && path != undefined) {
				var pos=path.lastIndexOf('\\');
				var pos2=path.lastIndexOf('/');
				if (pos!=-1) {
					leafName=path.slice(pos+1);
				} else if (pos2!=-1) {
					leafName=path.slice(pos2+1);
				} else {
					leafName=path;
				}
				
				if (leafName=='') {
					leafName='/';
				}
				
				var empty=isEmpty(path);
				
											/*	path,level,open,					name	,			has children,hidden	*/		
				fireflyStarterArray[i]=new Array(path,0,false,((val[1]!='' && val[1]!=undefined)?("[ "+val[1]+" ]  "):'')+leafName,empty,false);
			}
		}
		document.getElementById("elementList").view = treeView;
	} catch (e) {
		errorLogger(e);
	}
}

function isEmpty(path) {
	/* Determine if the folder is empty */
	try {
		var aFolder = Components.classes["@mozilla.org/file/local;1"].createInstance();
		if (aFolder) aFolder.QueryInterface(Components.interfaces.nsILocalFile);
		aFolder.initWithPath(path);
		try {
			var folderEntries=aFolder.directoryEntries;
		} catch (err) {
			return true;
		}
		while (folderEntries.hasMoreElements()) {
			var next=folderEntries.getNext().QueryInterface(Components.interfaces.nsILocalFile);
			if (next.isDirectory()) {
				return false;
			}
		}
	} catch (e) {
		errorLogger(e);
	}
	return true;
}
function folderClicked(event) {
	/* When click on a felder from the tree display the new folder in the active subwindow */
	try {
		var gBrowser=win.gBrowser;
		var mTabs=gBrowser.mTabs;
		for (var i=0;i<mTabs.length;i++) {
			if (gBrowser.getBrowserForTab(mTabs[i]).currentURI.spec==FIREFLY_XUL_FILE) {
				gBrowser.selectedTab=mTabs[i];
				document.getElementById('elementList').view.selectionChanged();
				return;
			}
		}
		// if there is no firefly tab opened open one
		var newTab = gBrowser.addTab(FIREFLY_XUL_FILE);
		newTab.setAttribute(FIREFLY_APP_NAME, 'true');
		newTab.setAttribute('class','tabbrowser-tab');
		newTab.label = FIREFLY_APP_NAME;
		gBrowser.selectedTab = newTab;
		setTimeout("document.getElementById('elementList').view.selectionChanged()",500);	// wai 500 milliseconds for the tab to open and then display the folder		
	} catch (e) {
		errorLogger(e);
	}
	//event.target.parentNode.view.selectionChanged();
}
function pausecomp(millis) {			 // waits millis milliseconds but freezes the interface
	date = new Date();
	var curDate = null;
	do { 
		var curDate = new Date(); }
	while(curDate-date < millis);
} 
function debug(aMsg) {
	setTimeout(function() { throw new Error("[debug] " + aMsg); }, 0);
}
function eraseContent(el) {		// erases all children of a tag
	var cycles=el.childNodes.length;
	for (var p=0;p<cycles;p++) {
		el.removeChild(el.childNodes[0]);
	}
}
function errorLogger(e) {
	var prefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
	var alertErrors=prefs.getBoolPref('extensions.firefly.alert_errors');
	if (alertErrors) {
		alert(e.message);
	}
	
	var date=new Date();
	var data='File name:'+(e.fileName?e.fileName:'')+'\tLine number:'+(e.lineNumber?e.lineNumber:'')+
		'\tDate:'+date.getDate()+'.'+date.getMonth()+'.'+date.getFullYear()+'\t'+date.getHours()+':'+date.getMinutes()+':'+date.getSeconds()+
		'\tMessage:'+(e.message?e.message:'')+'\tName:'+(e.name?e.name:'')+'\tConstructor:'+(e.constructor?e.constructor:'')+'\r\n';
	var file = Components.classes["@mozilla.org/file/directory_service;1"]
                     .getService(Components.interfaces.nsIProperties)
                     .get("ProfD", Components.interfaces.nsIFile);
	file.append('firefly.err');
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
                         .createInstance(Components.interfaces.nsIFileOutputStream);
	if (file.exists()) {
		if (file.fileSize>20000) {
			foStream.init(file,  0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
		} else {
			foStream.init(file,  0x02 | 0x08 | 0x10, 0664, 0); // write, create, append
		}
	} else {
		foStream.init(file,  0x02 | 0x08 | 0x20, 0664, 0); // write, create, truncate
		
	}
	
	foStream.write(data, data.length);
	foStream.close();
}


var observerService =Components.classes["@mozilla.org/observer-service;1"].getService(Components.interfaces.nsIObserverService);
var observer = {
	observe: function(subject,topic,data){
		/* Every second scan the hidden transfers and display data on the transfer panel */
		try {
			var transferEl;
			
			//var wm = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			// 			var win = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
			// 			   .getInterface(Components.interfaces.nsIWebNavigation)
			// 			   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
			// 			   .rootTreeItem
			// 			   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
			// 			   .getInterface(Components.interfaces.nsIDOMWindow);
			
			var statusbar=win.document.getElementById('fireflyTransferStatus');
			
			var transfersPanel=document.getElementById('fireflyTransfers');
			var transferElements=transfersPanel.childNodes;
			if (transfersPanel.childNodes.length!=statusbar.childNodes.length) {	// if the hidden transfer elements are different number than the displays erase all displays and create them again
				eraseContent(transfersPanel);
				var newTransfer;
				for (var i=0;i<statusbar.childNodes.length;i++) {
					newTransfer=document.createElement('box');
					newTransfer.setAttribute('class','transferBox');
					transfersPanel.appendChild(newTransfer);
				}
			}
			
			for (var i=0;i<statusbar.childNodes.length;i++) {		// for every hidden transfer associate his data with one of the displays
				transferEl=statusbar.childNodes[i];
				transfersPanel.childNodes[i].currentFile=transferEl.currentFile;
				transfersPanel.childNodes[i].totalFileSize=transferEl.totalFileSize;
				transfersPanel.childNodes[i].copiedSoFar=transferEl.copiedSoFar;
				transfersPanel.childNodes[i].currentFileSize=transferEl.currentFileSize;
				transfersPanel.childNodes[i].currentFilePosition=transferEl.currentFilePosition;
				transfersPanel.childNodes[i].pump=transferEl.pump;
				transfersPanel.childNodes[i].mainElement=transferEl;
				transfersPanel.childNodes[i].refresh();
			}
		} catch (e) {
			errorLogger(e);
		}
	},
	QueryInterface : function (aIID) {
				if (aIID.equals(Components.interfaces.nsIObserver) || 
					aIID.equals(Components.interfaces.nsISupports) ||
					aIID.equals(Components.interfaces.nsISupportsWeakReference))
					return this;
				throw Components.results.NS_NOINTERFACE;
			}

};
observerService.addObserver(observer,"metronome",true);